summaryrefslogtreecommitdiff
path: root/tests/mv/hard-3
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2003-03-01 13:18:25 +0000
committerJim Meyering <jim@meyering.net>2003-03-01 13:18:25 +0000
commit25a2ac8e3e6f94e470d190f0d91654e3710a098e (patch)
tree3fe10404e3a261aeefc50d307132437dbf574ef3 /tests/mv/hard-3
parentfa6cfd2ef344f5f0f2f4c29f83b2e64b26b44757 (diff)
downloadcoreutils-25a2ac8e3e6f94e470d190f0d91654e3710a098e.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/mv/hard-3')
-rwxr-xr-xtests/mv/hard-359
1 files changed, 59 insertions, 0 deletions
diff --git a/tests/mv/hard-3 b/tests/mv/hard-3
new file mode 100755
index 000000000..8acac8b3b
--- /dev/null
+++ b/tests/mv/hard-3
@@ -0,0 +1,59 @@
+#!/bin/sh
+# Ensure that using `cp --preserve=link' to copy hard-linked arguments
+# onto existing destinations works, even when one of the link operations fails.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ cp --version
+fi
+
+. $srcdir/../envvar-check
+PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+mkdir -p x dst/x || framework_failure=1
+touch dst/x/b || framework_failure=1
+chmod a-w dst/x
+touch a || framework_failure=1
+ln a x/b || framework_failure=1
+ln a c || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+# ======================================
+# This must fail.
+cp --preserve=link --parents a x/b c dst && fail=1
+
+# Source files must remain.
+test -f a || fail=1
+test -f x/b || fail=1
+test -f c || fail=1
+cd dst
+
+# Three destination files must exist.
+test -f a || fail=1
+test -f x/b || fail=1
+test -f c || fail=1
+
+# The i-node numbers of a and c must be the same.
+ia=`ls -i a|sed 's/ a//'`
+ic=`ls -i c|sed 's/ c//'`
+test $ia = $ic || fail=1
+
+# The i-node numbers of x/b must be different.
+ib=`ls -i x/b|sed 's/ .*//'`
+test $ia = $ib || fail=1
+
+(exit $fail); exit $fail